/* This file is part of the MPFRCPP Library.

  Copyright (c) 2006 -- 2007 Alexey V. Beshenov <bav.272304@gmail.com>.

  The MPFRCPP Library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public License as
  published by the Free Software Foundation; either version 2.1 of the
  License, or (at your option) any later version.

  The MPFRCPP Library is distributed in the hope that it will be
  useful, but WITHOUT ANY WARRANTY; without even the implied warranty
  of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with the MPFRCPP Library; see the file COPYING.LIB. If
  not, write to the Free Software Foundation, Inc., 51 Franklin Street,
  Fifth Floor, Boston, MA 02110-1301, USA. */

/**
 * @file rounding.hpp
 * @date 2007-03-23
 * mpfrcpp::Real round method.
 * INTERNAL HEADER, NOT TO BE USED DIRECTLY.
 */

#ifndef INCLUDED_BY_MPFRCPP
    #error THIS IS AN INTERNAL HEADER ONLY, NOT TO BE USED DIRECTLY
#endif

#ifndef MPFRCPP_REAL_ROUNDING
#define MPFRCPP_REAL_ROUNDING

namespace mpfrcpp {

    //------------------------------------------------------------

    void Real::round ( const Precision& p, const RoundMode& rm ) throw() {
        mpfr_prec_round ( getMpfrT (), p.getMpfrPrecT(), rm.getMpfrRndT() );
    }

    void Real::round ( const Precision& p ) throw() {
        mpfr_prec_round ( getMpfrT (), p.getMpfrPrecT(),
                          getParameters().getDefaultRoundMode().getMpfrRndT() );
    }

    //------------------------------------------------------------

} // namespace mpfrcpp

#endif // MPFRCPP_REAL_ROUNDING
